#include <cstdio>
#include <cstring>

#include <vector>
#include <algorithm>

using namespace std;
typedef long long llint;

const llint inf = 1000000000000000000LL;

#define MAXN 1005

vector< int > v[ MAXN ];
vector< int > p;

int N;
int a[ 5 * MAXN ];
int r[ 5 * MAXN ];
int who[ 5 * MAXN ];
int len[ 5 * MAXN ];
int bio[ 5 * MAXN ];
int t[ 5 * MAXN ][ 5 ];

llint cmod;

int er[ 5 * MAXN ];

vector< int > factors( int x ) {
  vector< int > ret;

  while( x != 1 ) {
    int now = 1;
    int curr = er[ x ];

    while( x % curr == 0 ) {
      x /= curr;
      now *= curr;
    }

    ret.push_back( now );
  }

  return ret;
}

vector< pair< int, int > > simplify( vector< pair< int, int > > eqs ) {
  vector< pair< int, int > > ret;

  for( int i = 0; i < eqs.size(); ++i ) {
    if( eqs[ i ].second == 1 ) continue;

    vector< int > f = factors( eqs[ i ].second );

    for( int j = 0; j < f.size(); ++j )
      ret.push_back( make_pair( eqs[ i ].first % f[ j ], f[ j ] ) );
  }

  for( int i = 0; i < ret.size(); ++i ) {
    for( int j = i+1; j < ret.size(); ++j )
      if( ret[i].second == ret[j].second ) ret[j].second = -1;
  }

  vector< pair< int, int > > fret;

  for( int i = 0; i < ret.size(); ++i ) {
    bool ok = ( ret[i].second != -1 );
    for( int j = 0; j < ret.size() && ok; ++j ) {
      if( i == j ) continue;
      if( ret[j].second % ret[i].second == 0 ) ok = 0;
    }
    if( ok ) fret.push_back( ret[i] );
  }

  return fret;
}

llint go( llint a, llint b, llint *x, llint *y ) {
  if( b == 0 ) { *x = 1; *y = 0; return a; }

  llint X, Y;

  llint ret = go( b, a % b, &X, &Y );

  *x = Y;
  *y = ( X - ( a / b ) );

  return ret;
}

llint invt( llint x, llint mod, llint bmod ) {
  cmod = mod;
  llint inv, r;

  printf( "gcd %lld\n", go( x, mod, &inv, &r ) );
  printf( "%lld\n", inv*x + r*mod );


  printf( "inv od %lld mod %lld je %lld\n", x, mod, inv );
  printf( "%lld\n", ( x * inv + 10*mod ) % mod );

  return ( x * inv ) % bmod;
}

llint solver( vector< pair< int, int > > eqs ) {
  vector< pair< int, int > > eqsp = simplify( eqs );
  
  for( int i = 0; i < eqsp.size(); ++i )
    printf( ":: %d %d\n", eqsp[i].first, eqsp[i].second );

  llint bmod = 1;

  for( int i = 0; i < eqsp.size(); ++i )
    bmod *= eqsp[i].second;

  llint Sol = 0;

  for( int i = 0; i < eqsp.size(); ++i ) {
    Sol += ( eqsp[i].first * invt( bmod / eqsp[i].second, eqsp[i].second, bmod ) ) % bmod;
    Sol %= bmod;
  }

  printf( "s %lld\n", Sol );

  return Sol;
}

llint calc( vector< int > p, int pos ) {
  vector< pair< int, int > > eqs;

  for( int i = 0; i < 5; ++i ) {
    if( t[ pos+i ][ p[i] ] == -1 ) {
      printf( "%d %d\n", i, p[i] );
      return inf;
    }
    eqs.push_back( make_pair( t[ pos+i ][ p[i] ], len[ who[ pos+i ] ] ) );
  }

  return solver( eqs );
}

void Solve() {
  memset( er, 0, sizeof er );

  for( int i = 2; i <= 5*N; ++i ) {
    if( er[ i ] != 0 ) continue;

    er[ i ] = i;
    for( int j = 2*i; j <= 5*N; j += i )
      er[ j ] = i;
  }

  for( int i = 0; i < 5*N; ++i ) {
    scanf( "%d", a + i ); 
    --a[i];
  }

  for( int i = 0; i < N; ++i )
    v[i].clear();

  for( int i = 0; i < 2*N; ++i ) 
    v[ i / 2 ].push_back( i );

  for( int i = 2*N; i < 4*N; ++i )
    v[ ( i - 2*N ) / 2 ].push_back( i );

  for( int i = 4*N; i < 5*N; ++i )
    v[ i - 4*N ].push_back( i );

  p.clear();

  for( int i = 0; i < N; ++i )
    for( int j = 0; j < v[i].size(); ++j )
      p.push_back( v[i][j] );
  /*

  for( int i = 0; i < p.size(); ++i )
    printf( "%d ", p[i]+1 );

  putchar( '\n' );
  */

  for( int i = 0; i < 5*N; ++i )
    r[p[i]] = i;

  memset( bio, 0, sizeof bio );

  int cycles = 0;
  for( int i = 0; i < 5*N; ++i ) {
    if( bio[i] ) continue;

    bio[i] = 1;
    who[i] = cycles;
    len[cycles] = 1;

    for( int j = p[i]; j != i; j = p[j] ) {
      who[ j ] = cycles;
      ++len[cycles];
      //bio[j] = 1;
    }

    ++cycles;
  }
  printf( "tu\n" );

  memset( t, -1, sizeof t );

  for( int i = 0; i < 5*N; ++i ) {
    if( a[i] > 4  ) continue;

    int now = 0;
    t[ i ][ a[i] ] = 0;

    for( int j = r[i]; j != i; j = r[j] ) {
      t[ j ][ a[i] ] = ++now;
      printf( "%d do %d ima %d\n", j, a[i], now );
    }
  }

  llint Sol = inf;
  /*

  for( int i = 0; i < N; i += 5 ) {
    vector< int > cp;

    for( int j = 0; j < 5; ++j )
      cp.push_back( j );

    do {
      Sol = min( Sol, calc( cp, i ) );
    } while( next_permutation( cp.begin(), cp.end() ) );
  }
  */

  vector< int > cp;
  cp.push_back( 0 );
  cp.push_back( 1 );
  cp.push_back( 2 );
  cp.push_back( 3 );
  cp.push_back( 4 );
  Sol = calc( cp, 5 );

  printf( "%lld\n", Sol );
}

int main( void )
{
  printf( "%lld\n", invt( 5, 9, 10 ) );
  for( ;; ) {
    scanf( "%d", &N );
    if( !N ) return 0;
    Solve();
  }

  return 0;
}
